VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Queue"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements IContainer

'----------------------------------------------------
'- HEAP DECLARATIONS --------------------------------
Private Enum Pointer
    [_]
End Enum
'----------------------------------------------------

Private Type ListItem
    Data    As String
    Prev_   As Pointer
    Next_   As Pointer
End Type

Private Type MemSeg
    Flag    As Byte
    Seg     As ListItem
End Type
'----------------------------------------------------

Private m_HeapSize  As Long
Private Heap()      As MemSeg
Private m_Dynamic   As Boolean
Private m_Steps     As Long
'----------------------------------------------------
'----------------------------------------------------

Private m_First As Pointer
Private m_Last  As Pointer
Private m_Count As Long
'----------------------------------------------------

Private Sub Class_Initialize()
    Call SetHeapSize(10)
    Call SetDynamic(True, 10)
End Sub

Private Sub Class_Terminate()
    Call IContainer_Clear
End Sub
'----------------------------------------------------

Private Sub IContainer_Clear()
    Dim pIter   As Pointer
    
    Do While m_First
        pIter = m_First
        m_First = Heap(m_First).Seg.Next_
        Call Free(pIter)
    Loop
    
    m_Last = 0
    m_Count = 0
End Sub

Private Function IContainer_Clone() As IContainer
    Set IContainer_Clone = New Queue
    
    Dim pIter As Pointer
    
    pIter = m_First
    
    Do While pIter
        Call IContainer_Clone.Push(Heap(pIter).Seg.Data)
        pIter = Heap(pIter).Seg.Next_
    Loop
End Function

Private Property Get IContainer_Peek() As String
    If m_Count > 0 Then _
        IContainer_Peek = Heap(m_First).Seg.Data
End Property

Private Sub IContainer_Push(Item As String)
    If m_Count = 0 Then
        m_First = Alloc()
        Heap(m_First).Seg.Data = Item
        m_Last = m_First
    Else
        Dim pTmp As Pointer
        
        pTmp = Alloc()
        Heap(pTmp).Seg.Data = Item
        Heap(m_Last).Seg.Next_ = pTmp
        Heap(pTmp).Seg.Prev_ = m_Last
        m_Last = pTmp
    End If
    
    m_Count = m_Count + 1
End Sub

Private Function IContainer_Pop() As String
    If m_Count > 0 Then
        IContainer_Pop = Heap(m_First).Seg.Data
        
        Dim pTmp As Pointer
        
        pTmp = m_First
        m_First = Heap(m_First).Seg.Next_
        
        Call Free(pTmp)
        
        m_Count = m_Count - 1
    End If
End Function

Private Property Get IContainer_Size() As Long
    IContainer_Size = m_Count
End Property

'----------------------------------------------------
'- HEAP IMPLEMENTATION ------------------------------
Private Sub SetHeapSize(Size As Long)
    m_HeapSize = Size
    ReDim Heap(1 To Size)
End Sub

Private Sub ReSize(Size As Long)
    m_HeapSize = Size
    ReDim Preserve Heap(1 To Size)
End Sub

Private Sub SetDynamic(Enabled As Boolean, Steps As Long)
    m_Dynamic = Enabled
    m_Steps = Steps
End Sub

Private Function Alloc() As Pointer
    For Alloc = 1 To m_HeapSize
        If Heap(Alloc).Flag = 0 Then
            Heap(Alloc).Flag = 1
            Exit Function
        End If
    Next Alloc
    
    If m_Dynamic Then
        Call ReSize(m_HeapSize + 10)
        Heap(Alloc).Flag = 1
    Else
        Call Err.Raise(vbObjectError, "GC::Alloc", "Heap overflow")
    End If
End Function

Private Sub Free(Segment As Pointer)
    Heap(Segment).Flag = 0
End Sub
